Subject: Re: [PATCH v4 1/3] bus: mhi: host: add mhi_power_down_keep_dev()

From: Kalle Valo <[email-masked]>
Date: Thu, 29 Feb 2024 21:35:34 +0200

Baochen Qiang <[email-masked]> writes:

> On 2/29/2024 6:12 PM, Manivannan Sadhasivam wrote:
>> On Wed, Feb 28, 2024 at 10:22:41AM +0800, Baochen Qiang wrote:
>>> ath11k fails to resume:
>>>
>>> ath11k_pci 0000:06:00.0: timeout while waiting for restart complete
>>>
>>> This happens because when calling mhi_sync_power_up() the MHI subsystem
>>> eventually calls device_add() from mhi_create_devices() but the device
>>> creation is deferred:
>>>
>>> mhi mhi0_IPCR: Driver qcom_mhi_qrtr force probe deferral
>>>
>>> The reason for deferring device creation is explained in dpm_prepare():
>>>
>>>          /*
>>>           * It is unsafe if probing of devices will happen during suspend or
>>>           * hibernation and system behavior will be unpredictable in this case.
>>>           * So, let's prohibit device's probing here and defer their probes
>>>           * instead. The normal behavior will be restored in dpm_complete().
>>>           */
>>>
>>> Because the device probe is deferred, the qcom_mhi_qrtr_probe() is not
>>> called and thus MHI channels are not prepared:
>>>
>>> So what this means that QRTR is not delivering messages and the QMI connection
>>> is not working between ath11k and the firmware, resulting a failure in firmware
>>> initialization.
>>>
>>> To fix this add new function mhi_power_down_keep_dev() which doesn't destroy
>>> the devices for channels during power down. This way we avoid probe defer issue
>>> and finally can get ath11k hibernation working with the following patches.
>>>
>>> Tested-on: WCN6855 hw2.0 PCI WLAN.HSP.1.1-03125-QCAHSPSWPL_V1_V2_SILICONZ_LITE-3.6510.30
>>>
>>> Signed-off-by: Kalle Valo <[email-masked]>
>>
>> Did Kalle co-author this patch? If so, his Co-developed-by tag should
>> be added.
>
> Hmm, I'm not sure...  I would like Kalle's thoughts on this.

IIRC I did only some simple cleanup before submitting the patch so I
don't think Co-developed-by is justified. I'm also fine with removing my
Signed-off-by.

-- 
https://patchwork.kernel.org/project/linux-wireless/list/

https://wireless.wiki.kernel.org/en/developers/documentation/submittingpatches